/*    
       This software may be used and distributed according to the terms of
       the GNU General Public License (GPL), incorporated herein by
       reference.  Drivers based on this skeleton fall under the GPL and
       must retain the authorship (implicit copyright) notice.
 
       This program is distributed in the hope that it will be useful, but
       WITHOUT ANY WARRANTY; without even the implied warranty of
       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
       General Public License for more details.
 */
package navigator;

import java.awt.*;

public class NavPoint2D extends Point
{
    //public static final double EPS = 1e-6;
    
    public NavPoint2D(int x, int y)
    {
	super(x, y);
    }
    
    public boolean isInvalid()
    {
	return x < 0 || y < 0;
    }

    public static float slope(Point a, Point b)
    {
	return slope(a.x, a.y, b.x, b.y);
    }

    public static float slope(int x1, int y1, int x2, int y2) 
    {
	if(x1 == x2)
	    return java.lang.Float.MAX_VALUE;
	else
	    return ((float)(y2-y1))/(x2-x1);
    }
  
    public static boolean isEq(Point a, Point b)
    {
	return a.x == b.x && a.y == b.y;
    }

    public int distanceSqInt(Point a)
    {
	int dx = x - a.x;
	int dy = y - a.y;
	return dx*dx + dy*dy;
    }

    public int distanceInt(Point a)
    {
	int dx = x - a.x;
	int dy = y - a.y;
	return (int) Math.round(Math.sqrt(dx*dx + dy*dy));
    }
}
