/*    
       This software may be used and distributed according to the terms of
       the GNU General Public License (GPL), incorporated herein by
       reference.  Drivers based on this skeleton fall under the GPL and
       must retain the authorship (implicit copyright) notice.
 
       This program is distributed in the hope that it will be useful, but
       WITHOUT ANY WARRANTY; without even the implied warranty of
       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
       General Public License for more details.
 */
package cricketdaemon.clientlib.parse;

import cricketdaemon.Util;
import cricketdaemon.clientlib.data.*;
import java.io.*;
import java.util.*;

/**
 * Parses subtypes contained within a "pos"ition type.
 *
 * @author Allen Miu
 */
class PosParseHandlerMap extends ParseHandlerMap
{
    public static PosParseHandlerMap instance = 
	new PosParseHandlerMap();

    protected PosParseHandlerMap()
    {
	super();
	register("x", "check_coord", "parse_x");
	register("y", "check_coord", "parse_y");
	register("z", "check_coord", "parse_z");

    }

    public boolean check_coord(Object o)
    {
	return o instanceof Position;
    }

    public void parse_x(Object dataStructure, String value)
	throws IOException 
    {
	Position a = (Position) dataStructure;
	a.x = Util.parseDouble(value);
    }

    public void parse_y(Object dataStructure, String value)
	throws IOException 
    {
	Position a = (Position) dataStructure;
	a.y = Util.parseDouble(value);
    }

    public void parse_z(Object dataStructure, String value)
	throws IOException 
    {
	Position a = (Position) dataStructure;
	a.z = Util.parseDouble(value);
    }
}
